'                                  HELP.BAS
'
'              programma per la visualizzazione di testi di HELP
'
'  versione 1.2                                                   rev. 01.91
'
' ------------------------------------------------------------------------------
'
'  N.B. il nome del primo file di HELP puo` essere specificato ponendolo nella
'       linea di comando con la quale si manda in esecuzione il programma
'               esempio:   C>HELP nomefile
'       se il nome non e` indicato, il primo file sara` denominato INIZIO.HLP
'       esso puo` contenere  i nomi di altri file;  per questi,  pur non
'       essendo richiesto dal programma, usero` sempre l'estensione .HLP
'
' ------------------------------------------------------------------------------

DECLARE SUB Testo (File$)

CONST MaxPages% = 15
DIM SHARED FileName$

PrimoFile$ = COMMAND$
IF PrimoFile$ = "" THEN PrimoFile$ = "INIZIO.HLP"
CALL Testo(PrimoFile$)
CLS
END

' ------------------------------------------------------------------------------
'
'  Segnalazione di errore se il file richiesto non e` presente
'
ErroreFile:
   CLS
   COLOR 0, 7
   LOCATE 24, 1
   PRINT USING "non riesco ad aprire il file \                                                 \"; FileName$;
   LOCATE 25, 1
   PRINT "premi un tasto qualsiasi per riprovare ...                                      ";
   DO
      K$ = INKEY$
   LOOP UNTIL K$ <> ""
   COLOR 7, 0
   RESUME

' ================================ Testo =======================================
'
'  Procedura per la visualizzazione di un testo di HELP
'
'  Variabili di ingresso:
'     File$     nome del file che contiene il testo (ASCII) di HELP
'               N.B. il file puo` contenere anche nomi di file da concatenare
'                    posti in righe che iniziano col carattere | (codice 124)
'
' ------------------------------------------------------------------------------
SUB Testo (File$)

   DIM A$(1 TO MaxPages, 1 TO 24), F$(1 TO 24)
   F = FREEFILE
   FileName$ = File$
   ON ERROR GOTO ErroreFile
      OPEN "I", #F, FileName$
   ON ERROR GOTO 0
   P = 0
   S = 0
   DO
      P = P + 1
      R = 0
      DO
         IF EOF(F) THEN EXIT DO
         LINE INPUT #F, L$
         C$ = LEFT$(L$, 1)
         IF C$ = CHR$(124) THEN
            S = S + 1
            F$(S) = RIGHT$(L$, LEN(L$) - 1)
         ELSE
            R = R + 1
            A$(P, R) = L$
         END IF
      LOOP UNTIL R = 24
      IF EOF(F) THEN EXIT DO
   LOOP
   SELECT CASE R
      CASE 0
         PZ = P - 1
      CASE 1 TO 23
         PZ = P
         FOR R1 = R + 1 TO 24
            A$(P, R1) = ""
         NEXT R1
      CASE 24
         PZ = P
   END SELECT
   SZ = S

   P = 1
   DO
      CLS
      FOR R = 1 TO 24
         LOCATE R, 1: PRINT A$(P, R);
      NEXT R
      COLOR 0, 7
      IF P = PZ AND SZ > 0 THEN
         LOCATE 23, 1
         PRINT " per maggiori informazioni su un argomento premi la lettera corrispondente      "
         PRINT "                                   oppure                                       ";
      END IF
      LOCATE 25, 1
      IF P = 1 AND PZ > 1 THEN
         PRINT " premi un tasto qualsiasi per continuare ...                                    ";
      ELSEIF P = PZ AND PZ = 1 THEN
         PRINT " premi un tasto qualsiasi per terminare la spiegazione ...                      ";
      ELSEIF P = PZ AND PZ > 1 THEN
         PRINT " premi PgUp per tornare indietro,  qualsiasi altro tasto per terminare ...      ";
      ELSE
         PRINT " premi PgUp per tornare indietro, qualsiasi altro tasto per continuare ...      ";
      END IF
      COLOR 7, 0
      DO
         K$ = INKEY$
      LOOP UNTIL K$ <> ""
      IF K$ = CHR$(0) + CHR$(73) THEN
         IF P > 1 THEN P = P - 1
      ELSE
         P = P + 1
      END IF
      IF P > PZ AND SZ > 0 THEN
         K = ASC(UCASE$(K$)) - 64
         IF K >= 1 AND K <= SZ THEN
            CALL Testo(F$(K))
            P = PZ
         END IF
      END IF
   LOOP UNTIL P > PZ

END SUB

