'                                  MASKT.BAS
'
'  procedure per la gestione di maschera di ingresso dati in modalita` testo
'
'  versione 2.1                                                   rev. 06.90
'

' ------------------ Dichiarazione delle procedure utilizzate ------------------

' funzioni del file FUNZIONI.BAS
DECLARE FUNCTION LCAR$ (V$, L!)
DECLARE FUNCTION LNUM$ (V!, L!)
DECLARE FUNCTION MAX! (A!, B!)
DECLARE FUNCTION MIN! (A!, B!)
DECLARE FUNCTION NUM$ (V!)
DECLARE FUNCTION RNUM$ (V!, L!)

' procedure di questo stesso file
DECLARE SUB Aspetta (Sec!)
DECLARE SUB AttivaTastoT (PO!, Cod!, Descr$)
DECLARE SUB ErrBeep ()
DECLARE SUB CampoT (Tipo!, UZ!, UF!(), UR!, UC!, UL!, UP$, UD$, UF!)
DECLARE SUB CAR (V$, L!, M!)
DECLARE SUB PaginaT (UZ!, UU!(), JZ!, UR!(), UC!(), UL!(), UD$(), UU!, SWC!)
DECLARE SUB PaginaT2 (MOV!, UZ!, UU!(), RZ!, CZ!, UR!(), UC!(), UL!(), UD$(), UU!, SWC!)

' -------------------------- Definizione di costanti ---------------------------

' le costanti sono qui definite con riferimento ad uno schermo in bianco e nero;
' possono essere variate per sfruttare meglio uno schermo a colori o particolare

CONST TestoPagina = 7, SfondoPagina = 0
CONST TestoCampi = 0, SfondoCampi = 7
CONST TestoCampoCorr = 0, SfondoCampoCorr = 7
CONST TestoTasti = 0, SfondoTasti = 7
CONST Ncol = 80, Nrig = 25, Riga1 = Nrig - 1

' ================================ Aspetta =====================================
'
'  Procedura che sospende l'esecuzione del programma per un assegnato tempo
'     (in secondi)
'
'  Variabili di ingresso:
'     Sec       tempo di attesa, in secondi
'
'  N.B. La versione 4.5 del Quick Basic fornisce, con significato analogo,
'       il comando  SLEEP Sec
' ------------------------------------------------------------------------------
SUB Aspetta (Sec)

    CONST SecInGiorno = 86400
    Fine = TIMER + Sec
    IF Fine > SecInGiorno THEN
       Fine = Fine - SecInGiorno
       DO WHILE TIMER > Fine
       LOOP
    END IF
    DO WHILE TIMER < Fine
    LOOP

END SUB

' ================================ AttivaTastoT ================================
'
'  Procedura che attiva un tasto operativo e visualizza sullo schermo
'  la relativa descrizione                       - in modalita` testo
'
'  Variabili di ingresso:   
'     PO        posizione del tasto funzione (da 1 a 10)
'     Cod       codice del tasto funzione; il valore 0 indica che il tasto
'                  e` disattivato
'     Descr$    descrizione del tasto
'
'  Costanti predefinite:
'     Riga1     riga superiore delle due riservate alla visualizzazione della
'                  descrizione dei tasti funzione attivati
'     Ncol      numero di colonne nella riga
'
'
' ---------------------------------------------------------------------------
SUB AttivaTastoT (PO, Cod, Descr$)

    Riga2 = Riga1 + 1
    ColT = (PO - 1) * Ncol / 10 + 1
    IF Cod = 0 THEN
       COLOR TestoPagina, SfondoPagina
       LOCATE Riga1, ColT: PRINT "       ";
       LOCATE Riga2, ColT: PRINT "       ";
       Cod$ = ""
    ELSE
       SELECT CASE Cod
          CASE -71: Tasto$ = "  Home "
          CASE -72: Tasto$ = "     " + CHR$(24) + " "
          CASE -73: Tasto$ = "  PgUp "
          CASE -75: Tasto$ = "     " + CHR$(27) + " "
          CASE -77: Tasto$ = "     " + CHR$(26) + " "
          CASE -79: Tasto$ = "   End "
          CASE -80: Tasto$ = "     " + CHR$(25) + " "
          CASE -81: Tasto$ = "  PgDn "
          CASE -82: Tasto$ = "   Ins "
          CASE -83: Tasto$ = "   Del "
          CASE 9:   Tasto$ = "  " + CHR$(27) + " Tab"
          CASE -15: Tasto$ = "  Tab " + CHR$(26)
          CASE 8:   Tasto$ = "  BkSp "
          CASE 127: Tasto$ = "  ^BkSp"
          CASE 13:  Tasto$ = "  Enter"
          CASE 10:  Tasto$ = "  ^Ente"
          CASE 27:  Tasto$ = "   ESC "
          CASE 1 TO 31:   Tasto$ = "    ^" + CHR$(Cod + 64) + " "
          CASE 32 TO 257: Tasto$ = "     " + CHR$(Cod) + " "
          CASE ELSE:      Tasto$ = "       "
       END SELECT
       COLOR TestoTasti, SfondoTasti
       LOCATE Riga1, ColT: PRINT Tasto$;
       LOCATE Riga2, ColT: PRINT Descr$;
       COLOR TestoPagina, SfondoPagina
       LOCATE Riga1, ColT: PRINT NUM$(PO);
       IF Cod < 0 THEN Cod$ = CHR$(127) + CHR$(-Cod) ELSE Cod$ = CHR$(Cod)
    END IF
    KEY PO, Cod$

END SUB

' ================================ CampoT ======================================
'
'  Procedura che effettua la gestione del singolo campo - in modalita` testo
'
'  Variabili di ingresso:
'     Tipo      indica quali caratteri devono essere accettati nel campo:
'                  Tipo = 0   tutti i caratteri
'                  Tipo = 1   solo cifre, segno meno e punto decimale
'     UZ        numero di codici di comandi di uscita
'     UF()      codici dei comandi di uscita dal campo
'     UR        riga in cui e` posizionato il campo
'     UC        colonna di inizio campo
'     UL        lunghezza (cioe` numero di caratteri) del campo
'     UP$       valore precedente o di default, da assegnare al campo quando
'                  si preme il tasto " (virgolette);
'                  cio` e` possibile solo se LEN(UP$)=UL;
'                  per rendere inattivo il tasto virgolette, porre UP$=""
'     UD$       contenuto iniziale del campo
'
'  Variabili di uscita:
'     UD$       contenuto finale del campo
'     UF        numero d'ordine del tasto di uscita premuto;
'                  quando si preme il tasto virgolette viene posto  UF = -1
'
'  Costanti predefinite:
'     TestoPagina       codice del colore da utilizzare per il testo nella pagina
'     SfondoPagina      codice del colore da utilizzare per lo sfondo della pagina
'     TestoCampi        codice del colore da utilizzare per il testo nei campi
'     SfondoCampi       codice del colore da utilizzare per lo sfondo dei campi
'     TestoCampoCorr    codice del colore da utilizzare per il testo nel campo corrente
'     SfondoCampoCorr   codice del colore da utilizzare per lo sfondo del campo corrente
'
'  Utilizza i sottoprogrammi:
'     Aspetta
'     ErrBeep
'
'  Annotazioni:
'     e` necessario definire la modalita` testo (SCREEN 0) prima di chiamare
'        il sottoprogramma;
'     il contenuto del campo corrente viene visualizzato con i colori relativi
'        al campo corrente;
'     la lunghezza di UD$ deve essere uguale a quella del campo; nel caso
'        sia diversa l'esecuzione si interrompe segnalando l'errore;
'     il tasto virgolette e` attivo solo se UP$ e` lungo quanto il campo;
'     se viene premuto il tasto virgolette si esce con  UF = -1.
'
' ------------------------------------------------------------------------------
SUB CampoT (Tipo, UZ, UF(), UR, UC, UL, UP$, UD$, UF)
    
    '      controllo lunghezza di UD$
    IF LEN(UD$) <> UL THEN
       LOCATE 1, 1
       PRINT "--- lunghezza del dato diversa da quella del campo ---"
       BEEP
       END
    END IF
    '      definizione valori iniziali
    UP = 0
    UI = 0
    UF = 0
    COLOR TestoCampoCorr, SfondoCampoCorr
    LOCATE UR, UC
    PRINT UD$;
    '
    DO
       '      aspetta che sia premuto un tasto facendo lampeggiare il cursore
       DO
          GOSUB CursoreOn
          UK$ = INKEY$
          IF UK$ <> "" THEN GOSUB CursoreOff: EXIT DO
          CALL Aspetta(.25)
          GOSUB CursoreOff
          UK$ = INKEY$
          IF UK$ <> "" THEN EXIT DO
          CALL Aspetta(.25)
       LOOP
       '      definisce il codice del tasto
       UK = ASC(UK$)
       IF UK = 127 THEN UK$ = INKEY$: UK = -ASC(UK$)
       IF UK = 0 THEN UK = -ASC(RIGHT$(UK$, 1))
       '      individua il tasto premuto
       FOR UV = 1 TO UZ
          IF UK = UF(UV) THEN    ' TastoUscita
             UF = UV
             IF UP <> 0 AND UP <> UL THEN
                MID$(UD$, UP + 1, UL - UP) = SPACE$(UL - UP)
             END IF
             EXIT FOR
          END IF
       NEXT UV
       IF UF = 0 THEN
          SELECT CASE UK
             CASE 34      ' TastoVirgolette
                IF LEN(UP$) <> UL THEN
                   CALL ErrBeep
                ELSE
                   UD$ = UP$
                   UF = -1
                END IF
             CASE 32 TO 127     ' Tasto carattere
                IF UP = UL OR (Tipo = 1 AND (UK < 45 OR UK > 57 OR UK = 47)) THEN
                   CALL ErrBeep
                ELSE
                   IF UI = 0 THEN
                      MID$(UD$, UP + 1, 1) = UK$
                      LOCATE UR, UC + UP
                      PRINT UK$;
                   ELSE
                      MID$(UD$, UP + 1, UL - UP) = UK$ + MID$(UD$, UP + 1, UL - UP - 1)
                      LOCATE UR, UC
                      PRINT UD$;
                   END IF
                   UP = UP + 1
                END IF
             CASE -77     ' CursoreAvanti
                IF UP = UL THEN CALL ErrBeep ELSE UP = UP + 1
                IF UI <> 0 THEN UI = 0
             CASE -75     ' CursoreIndietro
                IF UP = 0 THEN CALL ErrBeep ELSE UP = UP - 1
                IF UI <> 0 THEN UI = 0
             CASE 8       ' TastoBackspace
                IF UP = 0 THEN
                   CALL ErrBeep
                ELSE
                   MID$(UD$, UP, UL - UP + 1) = MID$(UD$, UP + 1, UL - UP) + " "
                   LOCATE UR, UC
                   PRINT UD$;
                   UP = UP - 1
                   IF UI <> 0 THEN UI = 0
                END IF
             CASE -83     ' TastoDelete
                IF UP = UL THEN
                   CALL ErrBeep
                ELSE
                   MID$(UD$, UP + 1, UL - UP) = MID$(UD$, UP + 2, UL - UP - 1) + " "
                   LOCATE UR, UC
                   PRINT UD$;
                   IF UI <> 0 THEN UI = 0
                END IF
             CASE -82     ' TastoInsert
                UI = 1 - UI
             CASE ELSE
                CALL ErrBeep
          END SELECT
       END IF
    LOOP UNTIL UF <> 0
    '      fine operazioni
    COLOR TestoCampi, SfondoCampi
    LOCATE UR, UC
    PRINT UD$;
    COLOR TestoPagina, SfondoPagina
EXIT SUB

CursoreOn:
    ' --- fa comparire il cursore
    IF UI = 0 THEN LOCATE UR, UC + UP, 1, 6, 7 ELSE LOCATE UR, UC + UP, 1, 3, 7
RETURN

CursoreOff:
    ' --- fa scomparire il cursore
    LOCATE UR, UC + UP, 0
RETURN

END SUB

' ================================ CAR =========================================
'
'  Procedura che trasforma una stringa V$ in una stringa di assegnata lunghezza
'
'  Variabili di ingresso:
'     V$        stringa di partenza
'     L         lunghezza della stringa da generare
'
'  Variabili di uscita:
'     V$        stringa di lunghezza L
'     M         indica l'effettuazione di modifica
'                  M = 0  stringa inalterata
'                  M = 1  stringa allungata
'                  M =-1  stringa accorciata
'
'  Annotazioni:
'     se la stringa di partenza e` troppo corta, la allinea a sinistra
'     se la stringa di partenza e` troppo lunga la tronca,
'        senza effettuare nessuna segnalazione
'     se L non e` un numero intero, viene troncato all'unita`
'
' ------------------------------------------------------------------------------
SUB CAR (V$, L, M)

    L0 = INT(L)
    Lung = LEN(V$)
    SELECT CASE Lung
       CASE IS > L0
          V$ = LEFT$(V$, L0)
          M = -1
       CASE L0
          M = 0
       CASE IS < L0
          V$ = V$ + SPACE$(L0 - Lung)
          M = 1
    END SELECT

END SUB

' ================================ ErrBeep =====================================
'  Procedura che effettua un beep come segnalazione di errore
' ------------------------------------------------------------------------------
SUB ErrBeep

    SOUND 415.35, 2.18
    SOUND 349.23, 2.64

END SUB

' ================================ PaginaT =====================================
'
'  Procedura che effettua la gestione di piu` campi - in modalita` testo
'
'  Variabili di ingresso:
'     UZ        numero di codici di uscita dalla pagina
'     UU()      codici di uscita dalla pagina
'     JZ        numero di campi
'     UR()      riga in cui e` posizionato ciascun campo
'     UC()      colonna di inizio di ciascun campo
'     UL()      lunghezza di ciascun campo
'     UD$()     contenuto iniziale di ciascun campo
'
'  Variabili di uscita:
'     UD$()     contenuto finale di ciascun campo
'     UU        numero d'ordine del tasto di uscita dalla pagina premuto
'     SWC       indica se sono state effettuate modifiche ai campi:
'                  SWC = 0      campi inalterati
'                  SWC = 1      almeno un campo e` stato modificato
'
'  Costanti predefinite:
'     TestoPagina       codice del colore da utilizzare per il testo nella pagina
'     SfondoPagina      codice del colore da utilizzare per lo sfondo della pagina
'     TestoCampi        codice del colore da utilizzare per il testo nei campi
'     SfondoCampi       codice del colore da utilizzare per lo sfondo dei campi
'
'  Utilizza i sottoprogrammi:
'     CampoT
'
'  Annotazioni:
'     e` necessario definire la modalita` testo (SCREEN 0) prima di chiamare
'        il sottoprogramma;
'     visualizza il contenuto dei campi;
'     se la lunghezza di un valore e` diversa da quella del campo la adegua
'        e pone SWC=1;
'     quando viene premuto il tasto virgolette, se il campo precedente ha
'        la stessa lunghezza del campo corrente il valore di quello viene
'        ricopiato in quest'ultimo e si passa al campo successivo;
'     nei campi sono ammessi tutti i caratteri;
'     non e` ancora inserito un controllo dei valori dei campi.
'
' ------------------------------------------------------------------------------
SUB PaginaT (UZ, UU(), JZ, UR(), UC(), UL(), UD$(), UU, SWC)

    DIM UF(3 + UZ)
    '
    '      valori predefiniti
    Tc = 0
    UF(1) = -71
    UF(2) = -72
    UF(3) = 13
    '
    '      codici di uscita dalla pagina
    FOR U = 1 TO UZ
       UF(U + 3) = UU(U)
    NEXT U
    '
    '      controlla la lunghezza e mostra il contenuto dei campi
    SWC = 0
    COLOR TestoCampi, SfondoCampi
    FOR J = 1 TO JZ
       CALL CAR(UD$(J), UL(J), SW)
       IF SW <> 0 THEN SWC = 1
       LOCATE UR(J), UC(J): PRINT UD$(J)
    NEXT J
    COLOR TestoPagina, SfondoPagina

    '      definisce valori iniziali
    J = 1
    UU = 0
    '
    DO
       '      individua il campo precedente
       UG = (J + JZ - 2) MOD JZ + 1
       '      gestione del singolo campo
       UD$ = UD$(J)
       CALL CampoT(Tc, UZ + 3, UF(), UR(J), UC(J), UL(J), UD$(UG), UD$, UF)
       '      controllo del valore del campo
       '      --- da inserire ---
       IF UD$ <> UD$(J) THEN SWC = 1
       UD$(J) = UD$
        '      esamina codice uscita singolo campo
       SELECT CASE UF
          CASE 1           ' passa al primo campo della pagina
             J = 1
          CASE 2           ' passa al campo precedente
             J = (J + JZ - 2) MOD JZ + 1
          CASE -1, 3       ' passa al campo successivo
             J = J MOD JZ + 1
          CASE IS > 3      ' esce dalla pagina
             UU = UF - 3
       END SELECT
    LOOP UNTIL UU <> 0

END SUB

' ================================ PaginaT2 ====================================
'
'  Procedura che effettua la gestione di un insieme bidimensionale di campi
'                                                      - in modalita` testo
'
'  Variabili di ingresso:
'     MOV       insieme di 4 cifre, che definiscono il movimento tra i campi
'               prima cifra (DIREZ)  - spostamento con ENTER:
'                                      DIREZ = 1  orizzontale
'                                            = 2  verticale
'               seconda cifra (ORIZ) - spostamento orizzontale:
'                                      ORIZ  = 1  con riavvolgimento nella riga
'                                            = 2  con andata a capo
'                                            = 3  passaggio all'inizio della colonna successiva
'               terza cifra (VERT)   - spostamento verticale:
'                                      VERT  = 1  con riavvolgimento nella colonna
'                                            = 2  con andata a capo
'                                            = 3  passaggio all'inizio della riga successiva
'               quarta cifra (PREC)  - direzione da cui il tasto " prende il valore precedente
'                                      PREC  = 1  orizzontale
'                                            = 2  verticale
'     UZ        numero di codici di uscita dalla pagina
'     UU()      codici di uscita dalla pagina
'     RZ        numero di righe in cui sono disposti i campi
'     CZ        numero di colonne in cui sono disposti i campi
'     UR()      riga dello schermo in cui e` posizionata ciascuna riga di campi
'     UC()      colonna dello schermo di inizio di ciascuna colonna di campi
'     UL()      lunghezza del campo di ciascuna colonna di campi
'     UD$()     contenuto iniziale di ciascun campo
'
'  Variabili di uscita:
'     UD$()     contenuto finale di ciascun campo
'     UU        numero d'ordine del tasto di uscita dalla pagina premuto
'     SWC       indica se sono state effettuate modifiche ai campi:
'                  SWC = 0      campi inalterati
'                  SWC = 1      almeno un campo e` stato modificato
'
'  Costanti predefinite:
'     TestoPagina       codice del colore da utilizzare per il testo nella pagina
'     SfondoPagina      codice del colore da utilizzare per lo sfondo della pagina
'     TestoCampi        codice del colore da utilizzare per il testo nei campi
'     SfondoCampi       codice del colore da utilizzare per lo sfondo dei campi
'
'  Utilizza i sottoprogrammi:
'     CampoT
'
'  Annotazioni:
'     e` necessario definire la modalita` testo (SCREEN 0) prima di chiamare
'        il sottoprogramma;
'     visualizza il contenuto dei campi;
'     se la lunghezza di un valore e` diversa da quella del campo la adegua;
'     il tasto virgolette ricopia il valore del campo precedente
'        (se di lunghezza corretta);
'     se viene premuto il tasto virgolette si passa al campo successivo;
'     nei campi sono ammessi tutti i caratteri;
'     non e` ancora inserito un controllo dei valori dei campi.
'
' ------------------------------------------------------------------------------
SUB PaginaT2 (MOV, UZ, UU(), RZ, CZ, UR(), UC(), UL(), UD$(), UU, SWC)
     
    DIM UF(6 + UZ)
    '
    '      parametri di movimento
    DIREZ = MOV \ 1000
    ORIZ = (MOV MOD 1000) \ 100
    VERT = (MOV MOD 100) \ 10
    PREC = MOV MOD 10
    '      valori predefiniti
    Tc = 0
    UF(1) = -71
    UF(2) = -72
    UF(3) = -80
    UF(4) = -75
    UF(5) = -77
    UF(6) = 13
    '
    '      codici di uscita dalla pagina
    FOR U = 1 TO UZ
       UF(U + 6) = UU(U)
    NEXT U
    '
    '      controlla la lunghezza e mostra il contenuto dei campi
    SWC = 0
    COLOR TestoCampi, SfondoCampi
    FOR R = 1 TO RZ
       FOR C = 1 TO CZ
          CALL CAR(UD$(R, C), UL(C), SW)
          IF SW <> 0 THEN SWC = 1
          LOCATE UR(R), UC(C): PRINT UD$(R, C)
       NEXT C
    NEXT R
    COLOR TestoPagina, SfondoPagina
    '
    '      definisce valori iniziali
    R = 1
    C = 1
    UU = 0
    '
    DO
       '      individua il campo precedente
       IF PREC = 1 THEN
          RP = R
          IF C = 1 THEN CP = CZ ELSE CP = C - 1
       ELSE
          IF R = 1 THEN RP = RZ ELSE RP = R - 1
          CP = C
       END IF
       '      gestione del singolo campo
       UD$ = UD$(R, C)
       CALL CampoT(Tc, UZ + 6, UF(), UR(R), UC(C), UL(C), UD$(RP, CP), UD$, UF)
       '      controllo del valore del campo
       '      --- da inserire ---
       IF UD$ <> UD$(R, C) THEN SWC = 1
       UD$(R, C) = UD$
       '      esamina codice uscita singolo campo
       IF UF = -1 OR UF = 6 THEN
          IF DIREZ = 1 THEN UF = 5 ELSE UF = 3
       END IF
       SELECT CASE UF
          CASE 1           ' passa al primo campo della pagina
             R = 1
             C = 1
          CASE 2           ' passa al campo di sopra
             GOSUB PrecedenteVert
             R = RP
             C = CP
          CASE 3           ' passa al campo di sotto
             GOSUB SuccessivoVert
             R = RS
             C = CS
          CASE 4           ' passa al campo a sinistra
             GOSUB PrecedenteOriz
             R = RP
             C = CP
          CASE 5           ' passa al campo a destra
             GOSUB SuccessivoOriz
             R = RS
             C = CS
          CASE IS > 6      ' esce dalla pagina
             UU = UF - 6
       END SELECT
    LOOP UNTIL UU <> 0
EXIT SUB

PrecedenteOriz:
    SELECT CASE ORIZ
       CASE 1
          RP = R
       CASE 2
          IF C = 1 THEN RP = (R + RZ - 2) MOD RZ + 1 ELSE RP = R
       CASE 3
          RP = 1
    END SELECT
    IF C = 1 THEN CP = CZ ELSE CP = C - 1
RETURN

SuccessivoOriz:
    SELECT CASE ORIZ
       CASE 1
          RS = R
       CASE 2
          IF C = CZ THEN RS = R MOD RZ + 1 ELSE RS = R
       CASE 3
          RS = 1
    END SELECT
    IF C = CZ THEN CS = 1 ELSE CS = C + 1
RETURN

PrecedenteVert:
    SELECT CASE VERT
       CASE 1
          CP = C
       CASE 2
          IF R = 1 THEN CP = (C + CZ - 2) MOD CZ + 1 ELSE CP = C
       CASE 3
          CP = 1
    END SELECT
    IF R = 1 THEN RP = RZ ELSE RP = R - 1
RETURN

SuccessivoVert:
    SELECT CASE VERT
       CASE 1
          CS = C
       CASE 2
          IF R = RZ THEN CS = C MOD CZ + 1 ELSE CS = C
       CASE 3
          CS = 1
    END SELECT
    IF R = RZ THEN RS = 1 ELSE RS = R + 1
RETURN

END SUB

' ================================ PaginaTf ====================================
'
'  Procedura che effettua la gestione di piu` campi - in modalita` testo
'                                                   - con tasti funzione
'  utilizza e visualizza i tasti funzione
'
'  Variabili di ingresso:
'     Cod()     array che contiene i possibili codici di tasti funzione
'     Descr$()  array che contiene la descrizione dei possibili tasti funzione
'     Utst()    array contenente 7 valori, uno per ciascuno dei tasti funzione
'                  disponibili (da 4 a 10):
'                  - il valore 0 indica che il tasto e` disattivato;
'                  - un valore >0 rappresenta il numero d'ordine della
'                    funzione associata al tasto (negli array precedenti);
'     JZ        numero di campi
'     UR()      riga in cui e` posizionato ciascun campo
'     UC()      colonna di inizio di ciascun campo
'     UL()      lunghezza di ciascun campo
'     UD$()     contenuto iniziale di ciascun campo
'
'  Variabili di uscita:
'     UD$()     contenuto finale di ciascun campo
'     UU        numero d'ordine del tasto di uscita dalla pagina premuto
'     SWC       indica se sono state effettuate modifiche ai campi:
'                  SWC = 0      campi inalterati
'                  SWC = 1      almeno un campo e` stato modificato
'
'  Costanti predefinite:
'     TestoPagina    codice del colore da utilizzare per il testo nella pagina
'     SfondoPagina   codice del colore da utilizzare per lo sfondo della pagina
'     Riga1     riga superiore delle due riservate alla visualizzazione della
'                  descrizione dei tasti funzione attivati
'     Ncol      numero di colonne nella riga
'
'  Utilizza i sottoprogrammi:
'     AttivaTastoT
'     PaginaT
'
'  Annotazioni:
'     e` necessario definire la modalita` testo (SCREEN 0) prima di chiamare
'        il sottoprogramma;
'     visualizza il contenuto dei campi;
'     se la lunghezza di un valore e` diversa da quella del campo la adegua
'        e pone SWC=1;
'     quando viene premuto il tasto virgolette, se il campo precedente ha
'        la stessa lunghezza del campo corrente il valore di quello viene
'        ricopiato in quest'ultimo e si passa al campo successivo;
'     nei campi sono ammessi tutti i caratteri;
'     non e` ancora inserito un controllo dei valori dei campi.
'
' ------------------------------------------------------------------------------
SUB PaginaTf (Cod(), Descr$(), Utst(), JZ, UR(), UC(), UL(), UD$(), UU, SWC)

    DIM UU(7)

    COLOR TestoPagina, SfondoPagina
    LOCATE Riga1 - 1, 1: PRINT STRING$(Ncol, 196);
    '      tasti predefiniti
    IF JZ = 1 THEN
       FOR I = 1 TO 3
          CALL AttivaTastoT(I, 0, "       ")
       NEXT I
    ELSE
       CALL AttivaTastoT(1, -71, "Inizio ")
       CALL AttivaTastoT(2, -72, "Preced.")
       CALL AttivaTastoT(3, 13, "Success")
    END IF
    '      tasti definiti dall'utente
    UZ = 0
    FOR I = 4 TO 10
       N = Utst(I - 3)
       IF N = 0 THEN
          CALL AttivaTastoT(I, 0, "       ")
       ELSE
          UZ = UZ + 1
          UU(UZ) = Cod(N)
          CALL AttivaTastoT(I, UU(UZ), Descr$(N))
       END IF
    NEXT I
    '      gestione dei campi
    CALL PaginaT(UZ, UU(), JZ, UR(), UC(), UL(), UD$(), UU, SWC)

END SUB

' ================================ PaginaTf2 ===================================
'
'  Procedura che effettua la gestione di un insieme bidimensionale di campi
'                                                      - in modalita` testo
'                                                      - con tasti funzione
'
'  Variabili di ingresso:
'     MOV       insieme di 4 cifre, che definiscono il movimento tra i campi
'               prima cifra (DIREZ)  - spostamento con ENTER:
'                                      DIREZ = 1  orizzontale
'                                            = 2  verticale
'               seconda cifra (ORIZ) - spostamento orizzontale:
'                                      ORIZ  = 1  con riavvolgimento nella riga
'                                            = 2  con andata a capo
'                                            = 3  passaggio all'inizio della colonna successiva
'               terza cifra (VERT)   - spostamento verticale:
'                                      VERT  = 1  con riavvolgimento nella colonna
'                                            = 2  con andata a capo
'                                            = 3  passaggio all'inizio della riga successiva
'               quarta cifra (PREC)  - direzione da cui il tasto " prende il valore precedente
'                                      PREC  = 1  orizzontale
'                                            = 2  verticale
'     Utst()    array contenente 10 valori, uno per ciascuno dei tasti funzione,
'                  che indicano  il numero d'ordine  (nel sottoprogramma  Tasto)
'                  della funzione associata al tasto;
'                  il valore 0 indica che il tasto e` disattivato;
'                  i primi tre valori  non sono utilizzati,  perche`  quei tasti
'                  sono assegnati alle funzioni interne alla pagina
'     RZ        numero di righe in cui sono disposti i campi
'     CZ        numero di colonne in cui sono disposti i campi
'     UR()      riga in cui e` posizionato ciascun campo
'     UC()      colonna di inizio di ciascun campo
'     UL()      lunghezza di ciascun campo
'     UD$()     contenuto iniziale di ciascun campo
'
'  Variabili di uscita:
'     UD$()     contenuto finale di ciascun campo
'     UU        numero d'ordine del tasto di uscita dalla pagina premuto
'     SWC       indica se sono state effettuate modifiche ai campi:
'                  SWC = 0      campi inalterati
'                  SWC = 1      almeno un campo e` stato modificato
'
'  Costanti predefinite:
'     TestoPagina    codice del colore da utilizzare per il testo nella pagina
'     SfondoPagina   codice del colore da utilizzare per lo sfondo della pagina
'     Riga1     riga superiore delle due riservate alla visualizzazione della
'                  descrizione dei tasti funzione attivati
'     Ncol      numero di colonne nella riga
'
'  Utilizza i sottoprogrammi:
'     AttivaTastoT
'     PaginaT2
'
'  Annotazioni:
'     e` necessario definire la modalita` testo (SCREEN 0) prima di chiamare
'        il sottoprogramma;
'     visualizza il contenuto dei campi;
'     se la lunghezza di un valore e` diversa da quella del campo la adegua;
'     il tasto virgolette ricopia il valore del campo precedente
'        (se di lunghezza corretta);
'     se viene premuto il tasto virgolette si passa al campo successivo;
'     nei campi sono ammessi tutti i caratteri;
'     non e` ancora inserito un controllo dei valori dei campi.
'
' ------------------------------------------------------------------------------
SUB PaginaTf2 (MOV, Cod(), Descr$(), Utst(), RZ, CZ, UR(), UC(), UL(), UD$(), UU, SWC)

    DIM UU(4)

    COLOR TestoPagina, SfondoPagina
    LOCATE Riga1 - 1, 1: PRINT STRING$(Ncol, 196);
    '      tasti predefiniti
    CALL AttivaTastoT(1, -71, "Inizio ")
    CALL AttivaTastoT(2, -72, "Sopra  ")
    CALL AttivaTastoT(3, -80, "Sotto  ")
    CALL AttivaTastoT(4, -75, "A sinis")
    CALL AttivaTastoT(5, -77, "A destr")
    CALL AttivaTastoT(6, 13, "Success")
    '      tasti definiti dall'utente
    UZ = 0
    FOR I = 7 TO 10
       N = Utst(I - 6)
       IF Cod(N) = 0 THEN
          CALL AttivaTastoT(I, 0, "       ")
       ELSE
          UZ = UZ + 1
          UU(UZ) = Cod(N)
          CALL AttivaTastoT(I, UU(UZ), Descr$(N))
       END IF
    NEXT I
    '      gestione dei campi
    CALL PaginaT2(MOV, UZ, UU(), RZ, CZ, UR(), UC(), UL(), UD$(), UU, SWC)

END SUB

